---
title: RTCPeerConnection.signalingState
slug: Web/API/RTCPeerConnection/signalingState
tags:
  - API
  - ICE
  - Media
  - Negotiation
  - Property
  - RTCPeerConnection
  - Read-only
  - Reference
  - Signaling
  - WebRTC
  - WebRTC API
  - signalingState
  - state
---
<p>{{WebRTCSidebar}}</p>

<p>The read-only <strong><code>signalingState</code></strong> property on the {{domxref("RTCPeerConnection")}} interface returns one of the string values specified by the <code>RTCSignalingState</code> enum; these values describe the state of the signaling process on the local end of the connection while connecting or reconnecting to another peer. See {{SectionOnPage("/en-US/docs/Web/API/WebRTC_API/Session_lifetime", "Signaling")}} for more details about the signaling process.</p>

<p>Because the signaling process is a state machine, being able to verify that your code is in the expected state when messages arrive can help avoid unexpected and avoidable failures. For example, if you receive an answer while the <code>signalingState</code> isn't <code>"have-local-offer"</code>, you know that something is wrong, since you should only receive answers after creating an offer but before an answer has been received and passed into {{domxref("RTCPeerConnection.setLocalDescription()")}}. Your code will be more reliable if you watch for mismatched states like this and handle them gracefully.</p>

<p>This value may also be useful during debugging, for example.</p>

<p>In addition, when the value of this property changes, a {{event("signalingstatechange")}} event is sent to the {{domxref("RTCPeerConnection")}} instance.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"> var <em>state</em> = <em>RTCPeerConnection</em>.signalingState;</pre>

<h3 id="Value">Value</h3>

<p>The allowed values are those included in the enum <code><a href="#RTCSignalingState_enum">RTCSignalingState</a></code>.</p>

<p id="RTCSignalingState_enum">{{page("/en-US/docs/Web/API/RTCPeerConnection", "RTCSignalingState enum", 0, 1)}}</p>

<h2 id="Example">Example</h2>

<pre class="brush: js">var pc = new RTCPeerConnection(configuration);
var state = pc.signalingState;</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('WebRTC 1.0', '#dom-peerconnection-signaling-state', 'RTCPeerConnection.signalingState') }}</td>
   <td>{{ Spec2('WebRTC 1.0') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCPeerConnection.signalingState")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Session_lifetime">Lifetime of a WebRTC session</a></li>
 <li>{{domxref("RTCPeerConnection")}}</li>
 <li>{{event("signalingstatechange")}}</li>
 <li><a href="/en-US/docs/Web/Guide/API/WebRTC">WebRTC</a></li>
</ul>
